package com.fjhx.flow.config;

import cn.hutool.extra.spring.SpringUtil;
import com.fjhx.flow.core.FlowBean;
import com.fjhx.flow.core.FlowDelegate;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.context.annotation.Configuration;

/**
 * 流程初始化bean
 */
@Slf4j
@Configuration
public class FlowInitializingBean implements InitializingBean {

    @Override
    public void afterPropertiesSet() {

        String[] beanNamesForType = SpringUtil.getBeanNamesForType(FlowDelegate.class);

        for (String beanName : beanNamesForType) {
            FlowDelegate flowDelegate = SpringUtil.getBean(beanName, FlowDelegate.class);
            FlowBean.addBean(flowDelegate.getFlowKey(), beanName);
            log.info("流程：{} 注册成功", flowDelegate.getFlowKey());
        }

    }

}
