package com.fjhx.flow.service.flow.impl;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.flow.entity.flow.dto.FlowDefinitionDto;
import com.fjhx.flow.entity.flow.po.FlowDefinition;
import com.fjhx.flow.entity.flow.po.FlowDefinitionNode;
import com.fjhx.flow.mapper.flow.FlowDefinitionMapper;
import com.fjhx.flow.service.flow.FlowDefinitionService;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * <p>
 * 流程定义 服务实现类
 * </p>
 *
 * @author
 * @since 2023-03-15
 */
@Service
public class FlowDefinitionServiceImpl extends ServiceImpl<FlowDefinitionMapper, FlowDefinition> implements FlowDefinitionService {

    @Override
    public void add(FlowDefinition flowDefinition) {
        // todo 判断是否已添加
        this.save(flowDefinition);
    }

    @Override
    public void addVersion(FlowDefinitionDto dto) {
        // todo 判断是否已添加
        this.save(dto);

        List<FlowDefinitionNode> flowDefinitionNodeList = dto.getFlowDefinitionNodeList();

        for (FlowDefinitionNode flowDefinitionNode : flowDefinitionNodeList) {
            Long oldId = flowDefinitionNode.getId();
            long newId = IdWorker.getId();
            flowDefinitionNode.setId(newId);

            for (FlowDefinitionNode item : flowDefinitionNodeList) {
                if (item.getParentId().equals(oldId)) {
                    item.setParentId(newId);
                }
            }
        }

    }

}
